<!DOCTYPE html>
<html xmlns:th="http://www.thymeleaf.org" xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      xmlns="http://www.w3.org/1999/xhtml">

<!-- Generic resources fragment-->
<div th:replace="fragments/header :: head (pageTitle = #{register.title})" th:remove="tag">
    <h1>Aquí va el contingut del head amb els metas i els css</h1>
</div>

</head>
<body>
<!-- Header fragment -->
<div th:replace="fragments/header :: header" th:remove="tag">
    <h1>Aquí va el contingut del header amb el seu menu</h1>
</div>

<!-- Page top section -->
<section class="page-top-section set-bg" th:attr="data-setbg=@{/img/header-bg/2.jpg}" data-setbg="img/header-bg/2.jpg">
    <div class="container">
        <h2 th:text="#{roles.title}">Títol dels personatges</h2>
    </div>
</section>
<!-- Page top section end -->

<!-- Blog section -->
<section class="blog-section spad">
    <div class="container">
        <a th:href="@{/roles/crud}"><img th:attr="src=@{'/img/animatedGif/newRole.gif'}" th:alt-title="#{roles.nou.button}" style="width:10%"></a>
        </div>
    <div  class="container">
        <table id="roles" class="table table-striped table-bordered" style="width:100%">
            <thead>
            <tr>
                <th>NAME</th>
                <th>ATTACK SUCCES</th>
                <th>CAST HEAL SUCCES</th>
                <th>DODGE</th>
                <th>HEAL</th>
                <th>INTERRUPT SUCCES</th>
                <th>ARMOR</th>
                <th>DAMAGE</th>
                <th>HEALTH</th>
                <th>ACTIONS</th>
            </tr>
            </thead>
            <tfoot>
            <tr>
                <th>NAME</th>
                <th>ATTACK SUCCES</th>
                <th>CAST HEAL SUCCES</th>
                <th>DODGE</th>
                <th>HEAL</th>
                <th>INTERRUPT SUCCES</th>
                <th>ARMOR</th>
                <th>DAMAGE</th>
                <th>HEALTH</th>
                <th>ACTIONS</th>
            </tr>
            </tfoot>
        </table>
    </div>

</section>

<!-- footer fragment -->
<div th:replace="fragments/footer :: footer" th:remove="tag">
    <h1>Aquí la informació del footer</h1>
</div>

<!-- Generic Scripts fragment -->
<div th:replace="fragments/header :: scripts" th:remove="tag">
    <h1>Aquí posem els javascripts</h1>
</div>

<script type="text/javascript">
    var table;
    var popUpHtml;
    /*<![CDATA[*/

    var messageEditSaveOk = '[[#{role.editok.popup}]]';

    var confirmButtonText = '[[#{confirm.popup}]]';
    var cancelButtonText = '[[#{cancel.popup}]]';
    var titleDelete = '[[#{role.deletetitle.popup}]]';
    var textDelete = '[[#{role.deletetext.popup}]]';

    /*]]>*/
    $(document).ready(function() {
        table = $('#roles').DataTable( {
            "ajax": {
                url: "/api/role",
                dataSrc: ''
            },
            "sPaginationType": "full_numbers",
            "columnDefs": [
                {
                "targets": [ 1, 2,3,4,5,6,7,8 ],
                "className": 'dt-right'
                },
                {
                "targets": [ 9 ],
                "className": 'dt-center'
                }
            ],
            "columns": [
                { "data": "name"},
                { "data": "attackSucces" },
                { "data": "castHealSucces" },
                { "data": "counterSucces" },
                { "data": "heal" },
                { "data": "interruptSucces"},
                { "data": "armadura"},
                { "data": "mal"},
                { "data": "salut"},
                { "data": "id",
                    "createdCell": function (td, cellData, rowData, row, col) {
                        var editIcon = "<a id='editH' href=javascript:openEditRole('"+
                        rowData.id +"',\""+
                        rowData.name+"\","+
                        rowData.attackSucces +","+
                        rowData.castHealSucces +","+
                        rowData.counterSucces +","+
                        rowData.heal +","+
                        rowData.interruptSucces +","+
                        rowData.armadura +","+
                        rowData.mal +","+
                        rowData.salut +
                        ")><i class='fas fa-edit'></i></a>";

                        var deleteIcon = "<a href=javascript:deleteRole('"+ rowData.id +"')><i class='fas fa-trash-alt' style='color:red'></i></a>";
                        var html = editIcon + deleteIcon;

                        $(td).html(html);
                    }
                }
            ]
        } );
        carregaPopUpFragment();
    } );

    function carregaPopUpFragment() {
        $.ajax({
            type: "GET",
            url: "/content/",
            success: function(data){
              popUpHtml=data;
            }
        });
    }

    function openEditRole(id, name, attackSucces, castHealSucces, dodgeSucces, heal, interruptSucces, armadura, mal, salut) {
        Swal.fire({
              title: 'Edit',
              html: popUpHtml,
              showCancelButton: true,
              showConfirmButton: true,
              confirmButtonColor: '#3085d6',
              cancelButtonColor: '#d33',
              witdth: 600,
              backdrop: `
                         rgba(0,0,123,0.4)
                         url("/img/animatedGif/editRole.gif")
                         right bottom
                         no-repeat
                        `
        })
        .then((result) => {
                var sendUrl = "/api/role/"+id+
                                        "?armadura="+$('#armadura').val()+
                                        "&attackSucces="+$('#attackSucces').val()+
                                        "&heal="+$('#heal').val()+
                                        "&castHealSucces="+$('#castHealSucces').val()+
                                        "&dodgeSucces="+$('#dodgeSucces').val()+
                                        "&interruptSucces="+$('#interruptSucces').val()+
                                        "&mal="+$('#mal').val()+
                                        "&salut="+$('#salut').val();
          if (result.value) {
            $.ajax({ url: sendUrl,
                     method: 'PUT'
            })
            .then(function (data) {
                table.ajax.reload();
                Swal.fire({

                    icon: 'success',
                    title: messageEditSaveOk,
                    showConfirmButton: true,
                    backdrop: `
                         rgba(0,0,123,0.4)
                         url("/img/animatedGif/editOk.gif")
                         right bottom
                         no-repeat
                        `

                })
            })
            .fail(function (err) {
                Swal.fire({
                    icon: 'error',
                    title: 'Oops...',
                    text: err.errors,
                    footer: err.status
                })
            });
          }
        })
        $('#name').val(name).attr("readonly","readonly");
        $('#attackSucces').val(attackSucces);
        $('#castHealSucces').val(castHealSucces);
        $('#dodgeSucces').val(dodgeSucces);
        $('#heal').val(heal);
        $('#interruptSucces').val(interruptSucces);
        $('#armadura').val(armadura);
        $('#mal').val(mal);
        $('#salut').val(salut);
    }

    function deleteRole(id){
        Swal.fire({
          title: titleDelete,
          text: textDelete,
          icon: 'warning',
          showCancelButton: true,
          confirmButtonColor: '#3085d6',
          cancelButtonColor: '#d33',
          confirmButtonText: confirmButtonText,
          cancelButtonText: cancelButtonText,
          backdrop: `
                     rgba(123,0,0,0.4)
                     url("/img/animatedGif/deleteRole.gif")
                     left bottom
                     no-repeat
                    `
        })
        .then((result) => {
          if (result.value) {
              var sendUrl = "/api/role/"+id;
              $.ajax({ url: sendUrl,
                         method: 'DELETE'
              })
              .then(function (data) {
                    table.ajax.reload();
                    Swal.fire(
                        'Deleted',
                        'Your role has been deleted.',
                        'success'
                    )
              })
              .fail(function (err) {
                    response = JSON.parse(err.responseText);
                    Swal.fire({
                        icon: 'error',
                        title: response.message,
                        text: response.errors[0],
                        footer: response.status
                    })
              });
          }
        })
    }

</script>

</body>
</html>
